# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class InstanceVolume(pulumi.CustomResource):
    from_snapshot_id: pulumi.Output[str]
    """
    Create a volume based on a image
    """
    from_volume_id: pulumi.Output[str]
    """
    Create a copy of an existing volume
    """
    name: pulumi.Output[str]
    """
    The name of the volume
    """
    organization_id: pulumi.Output[str]
    """
    The organization_id you want to attach the resource to
    """
    server_id: pulumi.Output[str]
    """
    The server associated with this volume
    """
    size_in_gb: pulumi.Output[float]
    """
    The size of the volume in gigabyte
    """
    type: pulumi.Output[str]
    """
    The volume type
    """
    zone: pulumi.Output[str]
    """
    The zone you want to attach the resource to
    """
    def __init__(__self__, resource_name, opts=None, from_snapshot_id=None, from_volume_id=None, name=None, organization_id=None, size_in_gb=None, type=None, zone=None, __props__=None, __name__=None, __opts__=None):
        """
        Creates and manages Scaleway Compute Instance Volumes. For more information, see [the documentation](https://developers.scaleway.com/en/products/instance/api/#volumes-7e8a39).

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] from_snapshot_id: Create a volume based on a image
        :param pulumi.Input[str] from_volume_id: Create a copy of an existing volume
        :param pulumi.Input[str] name: The name of the volume
        :param pulumi.Input[str] organization_id: The organization_id you want to attach the resource to
        :param pulumi.Input[float] size_in_gb: The size of the volume in gigabyte
        :param pulumi.Input[str] type: The volume type
        :param pulumi.Input[str] zone: The zone you want to attach the resource to
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['from_snapshot_id'] = from_snapshot_id
            __props__['from_volume_id'] = from_volume_id
            __props__['name'] = name
            __props__['organization_id'] = organization_id
            __props__['size_in_gb'] = size_in_gb
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['zone'] = zone
            __props__['server_id'] = None
        super(InstanceVolume, __self__).__init__(
            'scaleway:index/instanceVolume:InstanceVolume',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, from_snapshot_id=None, from_volume_id=None, name=None, organization_id=None, server_id=None, size_in_gb=None, type=None, zone=None):
        """
        Get an existing InstanceVolume resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] from_snapshot_id: Create a volume based on a image
        :param pulumi.Input[str] from_volume_id: Create a copy of an existing volume
        :param pulumi.Input[str] name: The name of the volume
        :param pulumi.Input[str] organization_id: The organization_id you want to attach the resource to
        :param pulumi.Input[str] server_id: The server associated with this volume
        :param pulumi.Input[float] size_in_gb: The size of the volume in gigabyte
        :param pulumi.Input[str] type: The volume type
        :param pulumi.Input[str] zone: The zone you want to attach the resource to
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["from_snapshot_id"] = from_snapshot_id
        __props__["from_volume_id"] = from_volume_id
        __props__["name"] = name
        __props__["organization_id"] = organization_id
        __props__["server_id"] = server_id
        __props__["size_in_gb"] = size_in_gb
        __props__["type"] = type
        __props__["zone"] = zone
        return InstanceVolume(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

