# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class LoadbalancerBeta(pulumi.CustomResource):
    ip_address: pulumi.Output[str]
    """
    The load-balance public IP address
    """
    ip_id: pulumi.Output[str]
    """
    The load-balance public IP ID
    """
    name: pulumi.Output[str]
    """
    Name of the lb
    """
    organization_id: pulumi.Output[str]
    """
    The organization_id you want to attach the resource to
    """
    region: pulumi.Output[str]
    """
    The region you want to attach the resource to
    """
    tags: pulumi.Output[list]
    """
    Array of tags to associate with the load-balancer
    """
    type: pulumi.Output[str]
    """
    The type of load-balancer you want to create
    """
    def __init__(__self__, resource_name, opts=None, name=None, organization_id=None, region=None, tags=None, type=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a LoadbalancerBeta resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: Name of the lb
        :param pulumi.Input[str] organization_id: The organization_id you want to attach the resource to
        :param pulumi.Input[str] region: The region you want to attach the resource to
        :param pulumi.Input[list] tags: Array of tags to associate with the load-balancer
        :param pulumi.Input[str] type: The type of load-balancer you want to create
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['name'] = name
            __props__['organization_id'] = organization_id
            __props__['region'] = region
            __props__['tags'] = tags
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['ip_address'] = None
            __props__['ip_id'] = None
        super(LoadbalancerBeta, __self__).__init__(
            'scaleway:index/loadbalancerBeta:LoadbalancerBeta',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, ip_address=None, ip_id=None, name=None, organization_id=None, region=None, tags=None, type=None):
        """
        Get an existing LoadbalancerBeta resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip_address: The load-balance public IP address
        :param pulumi.Input[str] ip_id: The load-balance public IP ID
        :param pulumi.Input[str] name: Name of the lb
        :param pulumi.Input[str] organization_id: The organization_id you want to attach the resource to
        :param pulumi.Input[str] region: The region you want to attach the resource to
        :param pulumi.Input[list] tags: Array of tags to associate with the load-balancer
        :param pulumi.Input[str] type: The type of load-balancer you want to create
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["ip_address"] = ip_address
        __props__["ip_id"] = ip_id
        __props__["name"] = name
        __props__["organization_id"] = organization_id
        __props__["region"] = region
        __props__["tags"] = tags
        __props__["type"] = type
        return LoadbalancerBeta(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

