# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Server(pulumi.CustomResource):
    boot_type: pulumi.Output[str]
    """
    the boot mechanism for this server. Possible values include `local` and `bootscript`
    """
    bootscript: pulumi.Output[str]
    """
    server bootscript
    """
    cloudinit: pulumi.Output[str]
    """
    allows you to define cloudinit script for this server
    """
    dynamic_ip_required: pulumi.Output[bool]
    """
    make server publicly available
    """
    enable_ipv6: pulumi.Output[bool]
    """
    enable ipv6
    """
    image: pulumi.Output[str]
    """
    base image of server
    """
    name: pulumi.Output[str]
    """
    name of server
    """
    private_ip: pulumi.Output[str]
    """
    private ip of the new resource
    """
    public_ip: pulumi.Output[str]
    """
    set a public ip previously created (a real ip is expected here, not its resource id)
    """
    public_ipv6: pulumi.Output[str]
    """
    if `enable_ipv6` is set this contains the ipv6 address of your instance
    """
    security_group: pulumi.Output[str]
    """
    assign security group to server
    """
    state: pulumi.Output[str]
    """
    allows you to define the desired state of your server. Valid values include (`stopped`, `running`)
    """
    state_detail: pulumi.Output[str]
    """
    contains details from the scaleway API the state of your instance
    """
    tags: pulumi.Output[list]
    """
    list of tags for server
    """
    type: pulumi.Output[str]
    """
    type of server
    """
    volumes: pulumi.Output[list]
    """
    attach additional volumes to your instance (see below)

      * `size_in_gb` (`float`)
      * `type` (`str`) - type of server
      * `volumeId` (`str`)
    """
    def __init__(__self__, resource_name, opts=None, boot_type=None, bootscript=None, cloudinit=None, dynamic_ip_required=None, enable_ipv6=None, image=None, name=None, public_ip=None, security_group=None, state=None, tags=None, type=None, volumes=None, __props__=None, __name__=None, __opts__=None):
        """
        **DEPRECATED**: This resource is deprecated and will be removed in `v2.0+`.
        Please use `.InstanceServer` instead.

        Provides servers. This allows servers to be created, updated and deleted.
        For additional details please refer to [API documentation](https://developer.scaleway.com/#servers).


        ## Volume

        You can attach additional volumes to your instance, which will share the lifetime
        of your `.Server` resource.

        > **Warning:** Using the `volume` attribute does not modify the System Volume provided default with every `.Server` instance. Instead it adds additional volumes to the server instance.

        > **Warning:** Some instance types require an additional volume to work. This includes for example *START-1M* and *VC1M*. If you run into this issue add an additional volume of the specified size.

        The `volume` mapping supports the following:

        * `type` - (Required) The type of volume. Can be `"l_ssd"`
        * `size_in_gb` - (Required) The size of the volume in gigabytes.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] boot_type: the boot mechanism for this server. Possible values include `local` and `bootscript`
        :param pulumi.Input[str] bootscript: server bootscript
        :param pulumi.Input[str] cloudinit: allows you to define cloudinit script for this server
        :param pulumi.Input[bool] dynamic_ip_required: make server publicly available
        :param pulumi.Input[bool] enable_ipv6: enable ipv6
        :param pulumi.Input[str] image: base image of server
        :param pulumi.Input[str] name: name of server
        :param pulumi.Input[str] public_ip: set a public ip previously created (a real ip is expected here, not its resource id)
        :param pulumi.Input[str] security_group: assign security group to server
        :param pulumi.Input[str] state: allows you to define the desired state of your server. Valid values include (`stopped`, `running`)
        :param pulumi.Input[list] tags: list of tags for server
        :param pulumi.Input[str] type: type of server
        :param pulumi.Input[list] volumes: attach additional volumes to your instance (see below)

        The **volumes** object supports the following:

          * `size_in_gb` (`pulumi.Input[float]`)
          * `type` (`pulumi.Input[str]`) - type of server
          * `volumeId` (`pulumi.Input[str]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['boot_type'] = boot_type
            __props__['bootscript'] = bootscript
            __props__['cloudinit'] = cloudinit
            __props__['dynamic_ip_required'] = dynamic_ip_required
            __props__['enable_ipv6'] = enable_ipv6
            if image is None:
                raise TypeError("Missing required property 'image'")
            __props__['image'] = image
            __props__['name'] = name
            __props__['public_ip'] = public_ip
            __props__['security_group'] = security_group
            __props__['state'] = state
            __props__['tags'] = tags
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['volumes'] = volumes
            __props__['private_ip'] = None
            __props__['public_ipv6'] = None
            __props__['state_detail'] = None
        super(Server, __self__).__init__(
            'scaleway:index/server:Server',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, boot_type=None, bootscript=None, cloudinit=None, dynamic_ip_required=None, enable_ipv6=None, image=None, name=None, private_ip=None, public_ip=None, public_ipv6=None, security_group=None, state=None, state_detail=None, tags=None, type=None, volumes=None):
        """
        Get an existing Server resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] boot_type: the boot mechanism for this server. Possible values include `local` and `bootscript`
        :param pulumi.Input[str] bootscript: server bootscript
        :param pulumi.Input[str] cloudinit: allows you to define cloudinit script for this server
        :param pulumi.Input[bool] dynamic_ip_required: make server publicly available
        :param pulumi.Input[bool] enable_ipv6: enable ipv6
        :param pulumi.Input[str] image: base image of server
        :param pulumi.Input[str] name: name of server
        :param pulumi.Input[str] private_ip: private ip of the new resource
        :param pulumi.Input[str] public_ip: set a public ip previously created (a real ip is expected here, not its resource id)
        :param pulumi.Input[str] public_ipv6: if `enable_ipv6` is set this contains the ipv6 address of your instance
        :param pulumi.Input[str] security_group: assign security group to server
        :param pulumi.Input[str] state: allows you to define the desired state of your server. Valid values include (`stopped`, `running`)
        :param pulumi.Input[str] state_detail: contains details from the scaleway API the state of your instance
        :param pulumi.Input[list] tags: list of tags for server
        :param pulumi.Input[str] type: type of server
        :param pulumi.Input[list] volumes: attach additional volumes to your instance (see below)

        The **volumes** object supports the following:

          * `size_in_gb` (`pulumi.Input[float]`)
          * `type` (`pulumi.Input[str]`) - type of server
          * `volumeId` (`pulumi.Input[str]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["boot_type"] = boot_type
        __props__["bootscript"] = bootscript
        __props__["cloudinit"] = cloudinit
        __props__["dynamic_ip_required"] = dynamic_ip_required
        __props__["enable_ipv6"] = enable_ipv6
        __props__["image"] = image
        __props__["name"] = name
        __props__["private_ip"] = private_ip
        __props__["public_ip"] = public_ip
        __props__["public_ipv6"] = public_ipv6
        __props__["security_group"] = security_group
        __props__["state"] = state
        __props__["state_detail"] = state_detail
        __props__["tags"] = tags
        __props__["type"] = type
        __props__["volumes"] = volumes
        return Server(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

